local assets=
{ 
    Asset("ANIM", "anim/magic_broom.zip"),--这个是放在地上的动画文件
    Asset("ANIM", "anim/magic_broom_swap.zip"), --这个是手上动画
    Asset("ATLAS", "images/inventoryimages/magic_broom.xml"),--物品栏图标的xml
    Asset("IMAGE", "images/inventoryimages/magic_broom.tex"),--物品栏图标的图片
}

local prefabs = 
{
}
--repair
local function ShouldAcceptItem(inst, item)
    if item.prefab == "goldnugget" then--想用药水补充但是没成功
       return true
    end
    return false
end

local function OnGetItemFromPlayer(inst, giver, item)
    if item.prefab == "goldnugget" then
       inst.components.finiteuses.current = inst.components.finiteuses.current + inst.components.finiteuses.total *0.5
    end
    if inst.components.finiteuses.current > inst.components.finiteuses.total then
       inst.components.finiteuses.current = inst.components.finiteuses.total
    end
	inst.components.finiteuses:Use(0)
end



local function OnEquip(inst, owner) --当你把武器装备到手上时，会触发这个函数
    owner.AnimState:OverrideSymbol("swap_object", "magic_broom_swap", "magic_broom_swap")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
	if owner.components.hunger then
        owner.components.hunger.burnrate = TUNING.MAGIC_BROOM_BASE_HUNGER  
    end
	inst:Turn_Off(inst)
	
	
end

local function OnUnequip(inst, owner) 
	--if owner.prefab == "marisa" then
	inst:Turn_Cancel(inst)
		--owner:Turn_Off(owner)
	--end
	
	if owner.components.hunger then
        owner.components.hunger.burnrate = 1
    end
	owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end


local function fn()

    local inst = CreateEntity()
	
	
	
    inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	inst.entity:AddNetwork()
    
    MakeInventoryPhysics(inst)   
    
    inst.AnimState:SetBank("magic_broom")
    inst.AnimState:SetBuild("magic_broom")
    inst.AnimState:PlayAnimation("idle")
	
	inst.entity:SetPristine()	
	
	if not TheWorld.ismastersim then
        return inst
    end
 

--可见性？	
	inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")--添加物品栏物品组件，只有有了这个组件，你才能把这个物品捡起放到物品栏里。
    inst.components.inventoryitem.imagename = "magic_broom" 
    inst.components.inventoryitem.atlasname = "images/inventoryimages/magic_broom.xml"
	inst.components.inventoryitem.keepondeath = true
--吃金	
    inst:AddComponent("trader")
    inst.components.trader.onaccept = OnGetItemFromPlayer
    inst.components.trader:SetAcceptTest(ShouldAcceptItem)

--耐久	
	inst:AddComponent("finiteuses")
	inst.components.finiteuses:SetMaxUses(TUNING.MAGIC_BROOM_DURABILITY)
	inst.components.finiteuses:SetUses(TUNING.MAGIC_BROOM_DURABILITY)
	
	local function OnFinish(inst)
		local owner = inst.components.inventoryitem.owner
		if owner and owner.prefab == "marisa" then
			--owner:Turn_Off(owner)
			inst:Turn_Cancel(inst)
		end
		inst:Remove()
	end
	if inst.components.finiteuses.current < 0 then
		inst.components.finiteuses.current = 0
		inst.components.finiteuses:SetOnFinished(OnFinish)
    end
	inst.components.finiteuses:SetOnFinished(OnFinish)
	
--武器	
	inst:AddComponent("weapon")     
    inst.components.weapon:SetDamage(TUNING.MAGIC_BROOM_DAMAGE)
    inst.components.weapon:SetRange(0)
	--inst.components.weapon:SetProjectile("fire_projectile")
	
	inst.components.weapon:SetOnAttack(function (weapon, attacker, target)
		--开启状态额外消耗san
		if inst._is_on then
			if attacker.components.sanity then
				attacker.components.sanity:DoDelta(-3)
			end
			inst.components.finiteuses:Use(1)
		else
			if attacker.components.sanity then
				attacker.components.sanity:DoDelta(-1)
			end
			--inst.components.finiteuses:Use(1)
		end
	end)

	


--关灯	
	inst.Turn_Off = function(inst)
		inst._is_on = false
		local owner = inst.components.inventoryitem.owner
		if owner and owner.prefab == "marisa" then
			owner.components.combat.damagemultiplier = 1
			owner.components.combat:SetAreaDamage(0, 0)
			--owner.components.health:SetAbsorptionAmount(.9)
			--owner.AnimState:OverrideSymbol("swap_object", "patchouli_book_swap", "patchouli_book_swap")
			--清除照明效果
			if inst.fx ~= nil then
				inst.fx:Remove()
				inst.fx = nil
			end
		end
	end
--开灯
	inst.Turn_On = function(inst)
		inst._is_on = true
		local owner = inst.components.inventoryitem.owner
		if owner and owner.prefab == "marisa" then
			owner.components.combat.damagemultiplier = 1.2
			owner.components.combat:SetAreaDamage(2, 0.1)
			--owner.components.health:SetAbsorptionAmount(.6)
			--owner.AnimState:OverrideSymbol("swap_object", "patchouli_book_open_swap", "patchouli_book_open_swap")
			--照明效果
			if inst.fx == nil then
				inst.fx = SpawnPrefab("magic_broom_light")
				inst.fx.persists = false
				inst.fx.entity:SetParent(owner.entity)
				inst.fx.entity:AddFollower()
				inst.fx.Follower:FollowSymbol(owner.GUID, "swap_object", 0, 0, 0)
			end
			
		end
	end
----还原为人物原状态
	inst.Turn_Cancel = function(inst)
		inst._is_on = false
		--inst.components.weapon:SetDamage(50)
		local owner = inst.components.inventoryitem.owner
		if owner and owner.prefab == "marisa" then
			owner.components.combat.damagemultiplier = 1
			owner.components.combat:SetAreaDamage(0, 0)
			--owner.components.health:SetAbsorptionAmount(0)
			--owner.AnimState:ClearOverrideSymbol("swap_object")
			if inst.fx ~= nil then
				inst.fx:Remove()
				inst.fx = nil
			end
		end
	end	
	
--开关
	inst:AddComponent("useableitem")
    inst.components.useableitem:SetOnUseFn(function(inst)
		local owner = inst.components.inventoryitem.owner
		if owner and owner.prefab == "marisa" then
			if inst._is_on then
				inst:Turn_Off(inst)
				owner:DoTaskInTime(0, function(owner)
					if owner.components.talker then
						if TUNING.LANG == 1 then
							owner.components.talker:Say("Magic infusion OFF")
						else
							owner.components.talker:Say("扫帚停止充能")
						end
					end
				end)
			else
				inst:Turn_On(inst)
				owner:DoTaskInTime(0, function(owner)
					if owner.components.talker then
					owner.components.sanity:DoDelta(-25)
						if TUNING.LANG == 1 then
							owner.components.talker:Say("Magic infusion ON")
						else
							owner.components.talker:Say("扫帚开始充能")
						end
					end
				end)
			end
			
		end
		inst.components.useableitem.inuse = false
	end)
	
	inst:AddComponent("equippable")--添加可装备组件，有了这个组件，你才能装备物品
    inst.components.equippable:SetOnEquip( OnEquip ) 
    inst.components.equippable:SetOnUnequip( OnUnequip )

		
--速度	
	inst.components.equippable.walkspeedmult = TUNING.MAGIC_BROOM_BASE_SPEED 
	
--专属
	if not inst.components.characterspecific then
		inst:AddComponent("characterspecific")
	end
 
	inst.components.characterspecific:SetOwner("marisa")
	inst.components.characterspecific:SetStorable(true)
	inst.components.characterspecific:SetComment("这力量我无法驾驭.") 
    return inst
end
if TUNING.LANG == 1 then
	STRINGS.NAMES.MAGIC_BROOM = "Magical Broom！"
	STRINGS.CHARACTERS.GENERIC.DESCRIBE.MAGIC_BROOM = "Full of explosive enchantment. Or not. "
else
	STRINGS.NAMES.MAGIC_BROOM = "魔法扫帚！"
	STRINGS.CHARACTERS.GENERIC.DESCRIBE.MAGIC_BROOM = "魔法使就该配把好扫帚！"
end
return Prefab("common/inventory/magic_broom", fn, assets, prefabs)--最后，返回这个实体到modmain里注册。Prefab这个函数，第一个参数只需要看最后一个/后面的部分，视为这个prefab的ID，fn则是上面定义的fn，是这个物品的创建函数，assets，对应上面的assets，主要是用于注册美术资源，如果你在这里注册了相应的美术资源，就不需要在modmain里再注册一次。prefabs，目前还未明确具体的作用。